<template>
  <div class="row">
      <div class="col-md-12">
          <h3></h3>
      </div>
      <div class="col-md-12">
          <ul class="list-group">
              <li v-for="(ticket) in tickets" :key="ticket" class="list-group-item">Id:{{ticket.id}},Title:{{ticket.title}},Description:{{ ticket.description }}</li>
          </ul>
      </div>
      <div class="row mt-3">
          <div class="col-md-12 text-center">
              <button @click="loadTickets" class="btn btn-md btn-primary">{{ 'Refresh' }}</button>
          </div>
      </div>
  </div>
</template>

<script setup lang="ts">
  import { ref, onMounted } from 'vue'
  import axios from 'axios'

  interface Ticket {
      id: string,
      title: string,
      description: string,
  }
  const tickets = ref([] as Ticket[])
  const fetchingTickets = ref(false)
  async function loadTickets() {
      fetchingTickets.value = true
      const ticketsResponse = await axios.get<Ticket[]>('http://localhost:8080/tickets')
      tickets.value.push(...(ticketsResponse.data || []))

      fetchingTickets.value = false
  }
  async function fetchInitialTickets() {
      const ticketsResponse = await axios.get<Ticket[]>('http://localhost:8080/tickets')
        tickets.value.push(...(ticketsResponse.data || []))
  }
  onMounted(async () => {
      await fetchInitialTickets()
  })
</script>